#include "arg.h"

int main(int argc, char *argv[])
{
	Int				opt1, opt2, size, noFork;
	Double			val;
	CChar			*scenePathP = 0;
	CChar			*str;
	Arg_form		*arg_format;

	// set options
	
	arg_format = arg_to_form(0,
		"", 										"usage: XXX [options]",
		
		"[%S]",	scenePathP,							"Specify scene file",

		"", ARG_SUBR(getAppFiles), 					"xxx",
		
		"-o1", ARG_FLAG(&opt1),						"option 1",
		"-o2", ARG_FLAG(&opt2), 					"option 2",
		"-size %d", &size, 							"set size",
		"-val %F", &val, 							"set value",
		"-str %S", &str, 							"set string",
		"-noFork", ARG_FLAG(&noFork), 				"don't fork Into background.",
			
		0);

	// No arguments: print usage
	if (argc == 1)
	{
		arg_form_print(arg_format);
		exit(1);
	}
	// parse arguments
	if (arg_parse_argv(argc, argv, arg_format) < 0)
		exit(1);

#ifndef DEBUG
	// fork into background
	if (!noFork && fork())
		exit(0);
#endif
}
