#include "cl/Register.h"
#include <string.h>


BaseTable *Register::table = 0;

Void PrintClassID(ostream &s, ClassID &id)
{
	char *t = (char*) &id;
	s << '<' << t[0] << t[1] << t[2] << t[3] << '>';
}


// --- Register methods ----------------------------------


Void Register::RegisterClass(
		ClassID         baseID,       
		ClassID         id,       
		ObjectCreator   creator,       
		const           Char *name,      
		const           Char *description      
	)
{
	Int			i = 0;
	ClassTable	*ctable;

	if (!table)
		table = new BaseTable;
	else
		while (i < table->NumItems())
		{
			if ((*table)[i].baseID == baseID)
				break;
			else
				i++;
		}
	
	if (i == table->NumItems())
	{
		table->Add(1);
		table->Last().baseID = baseID;
	}

	ctable = &((*table)[i].table);
	ctable->Add(1);
	ctable->Last().id = id;
	ctable->Last().creator = creator;
	ctable->Last().name = name;
	ctable->Last().description = description;
}

ClassTable *Register::FindClassTable(ClassID baseID)
{
	Int			i = 0;

	if (!table)
		table = new BaseTable;
	else
		while (i < table->NumItems())
		{
			if ((*table)[i].baseID == baseID)
				break;
			else
				i++;
		}	

	if (i < table->NumItems())
		return(&((*table)[i].table));
	else
		return(0);
}

Void Register::ListObjects(ClassID baseID)
{
	Int		i;
	ClassTable	*ctable = FindClassTable(baseID);

	if (!ctable)
		return;

	for (i = 0; i < ctable->NumItems(); i++)
	{
		cout << "  ";
		PrintClassID(cout, (*ctable)[i].id);
		cout << "  " << (*ctable)[i].name;
		if ((*ctable)[i].description)
			cout << ", " << (*ctable)[i].description;
		cout << endl;
	}
}

Void Register::ListObjects()
{
	Int			i, j;
	ClassTable	*ctable;
	
	if (!table) return;
	
	for (j = 0; j < table->NumItems(); j++)
	{
		PrintClassID(cout, (*table)[j].baseID);
		cout << endl;
		ctable = &((*table)[j].table);
		for (i = 0; i < ctable->NumItems(); i++)
		{
			cout << "  ";
			PrintClassID(cout, (*ctable)[i].id);
			cout << "  " << (*ctable)[i].name;
			if ((*ctable)[i].description)
				cout << ", " << (*ctable)[i].description;
			cout << endl;
		}
	}
}

Void *Register::MakeObject(ClassID id)
{
	return(MakeObject('none', id));
}

Void *Register::MakeObject(ClassID baseID, ClassID id)
{
	ClassTable	*ctable;
	Int			i = 0;

	if (!(ctable = FindClassTable(baseID)))
		return(0);

	while (i < ctable->NumItems())
	{
		if ((*ctable)[i].id == id)
			break;
		else
			i++;
	}
	
	if (i == ctable->NumItems())
	{
		Assert(false, "(Register::MakeObject) Can't find class ID");
		return(0);
	}
	return((*(*ctable)[i].creator)());
}

Void *Register::MakeObject(const Char *name)
{
	return(MakeObject('none', name));	
}

Void *Register::MakeObject(ClassID baseID, const Char *name)
{
	ClassTable	*ctable;
	Int			i = 0;
	
	if (!(ctable = FindClassTable(baseID)))
		return(0);
	
	while (i < ctable->NumItems())
	{
		if (strcmp((*ctable)[i].name, name) == 0)
			break;
		else
			i++;
	}
	
	if (i == ctable->NumItems())
	{
		Assert(false, "(Register::MakeObject) Can't find name");
		return(0);
	}
	return((*(*ctable)[i].creator)());
}

#include "cl/CLConfig.h"

#ifdef CL_TMPL_INST
template class Array<RegistryEntry>;
template class Array<BaseEntry>;
#endif

#ifdef CL_SGI_INST
#pragma instantiate Array<RegistryEntry>
#pragma instantiate Array<BaseEntry>
#endif

#ifdef TEST
Int main(Int argc, Char *argv[])
{

	return(0);
}
#endif
