/*! \mainpage

	GCL stands for "Graphics Class Library", and is a collection of
	useful graphics-oriented routines I use in my work.

	GCL includes the following:

		- Useful geometry and colour utilities. (Geometry.h, Colour.h)

		- Standard scene graph functionality for constructing and
		displaying hierarchical scenes. (SceneLang.h)

		- Readers and writers for a number of scene file formats.
		(SceneReader, SceneWriter.)

		- Support for a generic rendering class, Renderer. Current renderers:
			- OpenGL output (GLRenderer, GLXPane)
			- EPS (wireframe only) output (EPSRenderer).
			- Mesa direct-to-pixmap output (MesaRenderer).

		- A generic image class, Image, with support for 
			- Reading and writing ppm, tiff, gif, pic...
			- 8-bit grayscale, 32-bit colour, float-based colour.

		- A scene viewer class (ScenePane).

		- Support for avars, and simple keyframe animation. (Avars.h, Animation.h)

		- Support for multiresolution models; both edge-collapse
		(geometry simplification) and face-cluster (geometry
		aggregation). (MRModel.h)
		
		- Vector and Matrix utilities. (VecUtil.h, MatUtil.h)

		- Simple X windows window handling and image display support. 
		  (XGraphicsSystem, XPane, XEventPane)
				
	The default distribution builds the library, as well as a number of command line
	tools that use that library.	
*/
