/*
	File:		Draw.h

	Function:	Handy drawing routines.

	Author:		Andrew Willmott

	Copyright:  (c) 1998, Andrew Willmott
*/

#ifndef __Draw__
#define __Draw__

#include "gcl/Renderer.h"

Void DrawCircle(Renderer &r, const Point &p, const Vector &n,
				GCLReal radius);

Void PaintBox(Renderer &r, const Point &min, const Point &max);
Void FrameBox(Renderer &r, const Point &min, const Point &max);

Void PaintRect(Renderer &r, const Coord &min, const Coord &max);
Void FrameRect(Renderer &r, const Coord &min, const Coord &max);

Void MakeBoxCorners(const Point &min, const Point &max, Point corners[8]);
Void PaintBox(Renderer &r, Point c[8]);
Void FrameBox(Renderer &r, Point c[8]);

extern Int scRenderSteps;

#endif
