/*
    File:       MatUtil.h

    Function:	Provides useful matrix utilities

    Author:     Andrew Willmott

    Copyright:  (c) 1999, Andrew Willmott
*/

#ifndef __MatUtil__
#define __MatUtil__

#include "gcl/Image.h"
#include "gcl/Geometry.h"

Void ImageToMat(const Image &img, Matf &mat, ImgChannel chn = chMono);
///< Converts an image to a matrix
Void MatToImage(const Matf &mat, Image &img, ImgChannel chn = chMono);
///< Makes an image out of a matrix

Void MakeAbs(Matf &mat);
///< replace each element with its absolute value
Void ClipToZeroOne(Matf &mat);
///< clip each element to the interval [0, 1]

Void MakeRandomRotation(Vector v, VecTrans &m);
///< Create a random rotation matrix from the random vector v.

#endif
